package tech.loedige;

import util.Dump;

import javax.crypto.*;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;

public class Main {

    public static void main(String[] args) throws NoSuchPaddingException, InvalidKeyException, NoSuchAlgorithmException, IllegalBlockSizeException, BadPaddingException, InvalidAlgorithmParameterException {
	// write your code here
        byte[] key = Dump.hexString2byteArray("2F C6 0D 4C B3 44 6F 68 4C D8 7B 56 E2 93 4A 95");
        byte[] iv = Dump.hexString2byteArray("E7 80 29 0F 30 66 E8 A2 C0 40 19 0A 16 9C E9 DF");
        byte[] secret = Dump.hexString2byteArray("51 85 FC 42 A4 28 A3 E2 B3 83 7C D6 8D E1 F8 7F" +
                "C1 A4 AF 77 B7 29 BA 77 47 DF 1A 85 82 A1 09 6E " +
                "6E F6 A3 A1 5E 90 54 DB 33 71 00 00 00 00 00 00 " +
                "36 B5 1D E8 68 A6 91 91 4D 8F 09 A0 9B CF E8 55");
        System.out.println(Dump.dump(secret));
        byte[] message = decryptCTS(key,iv,secret);
        System.out.println(Dump.dump(message));
    }

    private static byte[] decryptCTS(byte[] key, byte[] iv, byte[] secret) throws InvalidAlgorithmParameterException, InvalidKeyException, NoSuchPaddingException, NoSuchAlgorithmException, BadPaddingException, IllegalBlockSizeException {
        Cipher cipher = Cipher.getInstance("AES/CTS/NoPadding");
        SecretKey secretKey = new SecretKeySpec(key,"AES");
        IvParameterSpec IV = new IvParameterSpec(iv);
        cipher.init(Cipher.DECRYPT_MODE,secretKey,IV);
        return cipher.doFinal(secret);
    }
}
